from .rrd_manager import RRDManager, directory_exists
from .config import config
import rrdtool
import os

class RRDSensorManager(RRDManager):
    def __init__(self,*args,**kwargs):
        super().__init__(*args,**kwargs)


    def rrd_create(self,save_dir, filename, length,machine_type, step, starttime=None):
        #https://oss.oetiker.ch/rrdtool/doc/rrdcreate.en.html
        rrd_configs = config["default"]
        if machine_type in config:
            rrd_configs = config[machine_type]

        if not directory_exists(save_dir):
            try:
                os.makedirs(save_dir)
            except:
                return

        ds_configs = []
        #for more flexibility, we should move this to the config. This would
        #allow us to use different configurations for each value.
        for i in range(1, length + 1):
            ds_name = f'value_{i}'
            ds_config = f'DS:{ds_name}:GAUGE:{rrd_configs["heartbeat"]}:{rrd_configs["min"]}:{rrd_configs["max"]}'
            ds_configs.append(ds_config)

        rrd_rra_configs = [
            f'RRA:{rra_config["cf"]}:{rra_config["xff"]}:{rra_config["pdp_per_row"]}:{rra_config["rows"]}'
            for rra_config in rrd_configs["rra_configs"]
        ]

        rrdtool.create(
            filename,
            f'--step={rrd_configs["step"]}',
            '--no-overwrite',
            *ds_configs,
            *rrd_rra_configs
        )

