config = {
    "pump": {
      "step": 1, #seconds between rows
      "rra_configs": [
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 1, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 60, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 600, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 3600, 'xff': 0.1}
      ], 
      "heartbeat": 60,
      "min": -100, 
      "max": 10000
    },
    "power": {
      "step": 60, #seconds between rows
      "rra_configs": [
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 1, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 10, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 60, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 360, 'xff': 0.1}
      ], 
      "heartbeat": 120,
      "min": -100, 
      "max": 10000
    },
    "default": {
      "step": 1, #seconds between rows
      "rra_configs": [
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 1, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 60, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 600, 'xff': 0.1},
          {'cf': 'AVERAGE', 'rows': 288, 'pdp_per_row': 3600, 'xff': 0.1}
      ], 
      "heartbeat": 60,
      "min": -100, 
      "max": 10000
    }
}

#https://oss.oetiker.ch/rrdtool/doc/rrdcreate.en.html
#heartbeat defines the maximum number of seconds that may pass between two updates of this data source before the value of the data source is assumed to be *UNKNOWN*.
#min and max define the expected range values for data supplied by a data source. If min and/or max are specified any value outside the defined range will be regarded as *UNKNOWN*. If you do not know or care about min and max, set them to U for unknown. Note that min and max always refer to the processed values of the DS. For a traffic-COUNTER type DS this would be the maximum and minimum data-rate expected from the device.
#If information on minimal/maximal expected values is available, always set the min and/or max properties. This will help RRDtool in doing a simple sanity check on the data supplied when running update.