gauges = {}
import simplejson as json

try:
    from uci import Uci
    import subprocess

    u = Uci()

    def add_uci_section(category,name):
        u.set("novatec_statistics",category+'_'+name,"statistics")

    def get_uci_gauges(category,name):
        try:
            uci_gauges = u.get('novatec_statistics', category+'_'+name, 'graphs')
        except:
            add_uci_section(category,name)
            uci_gauges = ()
        return uci_gauges
    
    def add_gauges_to_uci(category,subcategory):
        uci_gauges = get_uci_gauges(category,subcategory)
        # print('current graphs:',uci_gauges)
        global gauges
        if category not in gauges:
            return
        if subcategory not in gauges[category]:
            return
        
        gauges_tuple=tuple(set(uci_gauges).union(set(gauges[category][subcategory])))
        # for gauge in gauges[category][subcategory]:
        #     # gauge = gauge_type.strip().replace(' ','')
        #     if gauge not in uci_gauges:
        #         uci_gauges = (gauge,) + uci_gauges
        
        # gauges_tuple = tuple(uci_gauges)
        # print(gauges_tuple)
        if gauges_tuple != uci_gauges:
            print("Gauge list updated, saving new list")
            u.set('novatec_statistics', category+'_'+subcategory, 'graphs', gauges_tuple)
            u.commit('novatec_statistics')
except Exception as e:
    # def add_gauge_for_uci(gauge_type):
    #     pass

    def add_gauges_to_uci(category,name):
        pass

def add_gauge_for_uci(message):
    global gauges

    subcategory = message['subcategory']
    gauge_name = message['rrd_name']
    category = message['category']
    if category not in gauges:
        gauges[category]={}
    if subcategory not in gauges[category]:
        gauges[category][subcategory] = []
    if gauge_name not in gauges[category][subcategory]:
        gauges[category][subcategory].append(gauge_name)
    print("gauges: ", gauges)
    add_gauges_to_uci(category,subcategory)