# import os
import zmq
# from config import config
# import rrdtool
import argparse
# from luci_uci import add_gauges_to_uci
from pynovatec_rrd import RRDSensorManager

parser = argparse.ArgumentParser()
parser.add_argument("-p", "--port", type=int, default=7778, help="Port to listen on")
parser.add_argument("-ip", "--ip", type=str, default="127.0.0.1", help="IP to listen on")
parser.add_argument("-dir", "--directory_path", type=str, default="/tmp/rrd/OpenWrt", help="Directory to save rrd files in")
parser.add_argument("-machine_type", "--machine_type", type=str, default="pump", help="What type of machine is this? pump, power, etc.")
args = parser.parse_args()

# Socket to talk to server
context = zmq.Context()
socket = context.socket(zmq.SUB)

# print("Reporting data from server from port %s..." % args.port)
socket.connect ("tcp://%s:%s" % (args.ip, args.port))
socket.subscribe("")

# hostname = u.get('luci_statistics', 'collectd', 'Hostname') + "/"
# rrd_dir = u.get('luci_statistics', 'collectd_rrdtool', 'DataDir') + "/"
#default hostname is 'OpenWrt'
#default rrd_dir is '/tmp/rrd/

def process_message(message):

    m = {
        "category_type": args.machine_type,
        "category": args.machine_type,
        "subcategory": message["sensor_id"],
        "rrd_name": message["dataType"]+"_"+message["dataTypeIndex"],
        "values": message["values"],
        "length": len(message["values"]),
        "timestamp": None,
        "step": None
    }
    rrd_manager.save(m)
    # filename = args.directory_path + args.machine_type + "-" + message["sensor_id"]+"/" + message["dataType"]+"_"+message["dataTypeIndex"]+'.rrd'
    # if not os.path.exists(filename):
    #    rrd_directory = args.directory_path + args.machine_type + "-" + message["sensor_id"]
    #    create_rrd_file(rrd_directory, filename, len(message["values"]))

    # try:
    #     values = 'N:'+':'.join(message["values"])
    #     rrdtool.update(filename, values)
    #     # print(f"Updated RRD file: {filename} --- with {values}")
    # except Exception as e:
    #     pass
    #     # print(f"Error updating file: {str(e)}")
    # add_gauges_to_uci(args.machine_type, message)
    
def get_zmq_data_format2(val):
    #val = socket.recv_string()
    s = val.split(",")
    mac=s[1]
    uuid = mac.replace(":","").lower()
    dataType=s[4]
    sensor_type=s[2]
    index=s[3]
    dataTypeIndex=s[5]
    timeStamp=s[0]
    values=s[6:]
    s = timeStamp.split('.')
    ts=float(s[0])/1000

    return {
        'sensorType': sensor_type,
        'sensor_id': f"{uuid}_{sensor_type}_{index}",
        'mac': mac,
        'dataType': dataType,
        'dataTypeIndex': dataTypeIndex,
        'index': index,
        'uuid': uuid,
        'timeStamp': timeStamp,
        'ts': ts,
        'values': values
    }

# def directory_exists(directory_path):
#     return os.path.exists(directory_path) and os.path.isdir(directory_path)

# def create_rrd_file(save_dir, filename, length):
#     #https://oss.oetiker.ch/rrdtool/doc/rrdcreate.en.html
#     rrd_configs = config["default"]
#     if args.machine_type in config:
#         rrd_configs = config[args.machine_type]

#     if not directory_exists(save_dir):
#       try:
#           os.makedirs(save_dir)
#       except:
#           return

#     ds_configs = []
#     #for more flexibility, we should move this to the config. This would
#     #allow us to use different configurations for each value.
#     for i in range(1, length + 1):
#         ds_name = f'value_{i}'
#         ds_config = f'DS:{ds_name}:GAUGE:{rrd_configs["heartbeat"]}:{rrd_configs["min"]}:{rrd_configs["max"]}'
#         ds_configs.append(ds_config)

#     rrd_rra_configs = [
#         f'RRA:{rra_config["cf"]}:{rra_config["xff"]}:{rra_config["pdp_per_row"]}:{rra_config["rows"]}'
#         for rra_config in rrd_configs["rra_configs"]
#     ]

#     rrdtool.create(
#         filename,
#         f'--step={rrd_configs["step"]}',
#         '--no-overwrite',
#         *ds_configs,
#         *rrd_rra_configs
#     )

    

    # print(f'RRD file "{filename}" created successfully.')
rrd_manager = RRDSensorManager(args.directory_path,args.machine_type)

while True:
    zmq_string = socket.recv_string()
    message_dict = get_zmq_data_format2(zmq_string)
    # print(f"RECV: {str(zmq_string)}")
    process_message(message_dict)